CodeForces 615B Longtail Hedgehog

来源:互联网 发布:win7 64 windows文件夹 编辑:程序博客网 时间:2024/06/05 00:31

题意:给一个图,可以选择几个连续的段,并且编号要递增,然后答案就是这个段的长度*最后一个结点的边数

思路:简单DP,dp[i]=max(dp[i],dp[j]+1)然后跑一遍就好了


#include<bits/stdc++.h>using namespace std;const int maxn = 100005;#define LL long longint dp[maxn];vector<int>e[maxn];int cnt[maxn];int main(){    int n,m;scanf("%d%d",&n,&m);for (int i = 1;i<=m;i++){int u,v;scanf("%d%d",&u,&v);if (u<v)swap(u,v);e[u].push_back(v);cnt[u]++;cnt[v]++;}LL ans = 0;for (int i = 1;i<=n;i++){for (int j = 0;j<e[i].size();j++)dp[i]=max(dp[i],dp[e[i][j]]);dp[i]++;ans = max(ans,1LL*dp[i]*cnt[i]);}printf("%lld\n",ans);}


Description

This Christmas Santa gave Masha a magic picture and a pencil. The picture consists of n points connected by m segments (they might cross in any way, that doesn't matter). No two segments connect the same pair of points, and no segment connects the point to itself. Masha wants to color some segments in order paint a hedgehog. In Mashas mind every hedgehog consists of a tail and some spines. She wants to paint the tail that satisfies the following conditions:

  1. Only segments already presented on the picture can be painted;
  2. The tail should be continuous, i.e. consists of some sequence of points, such that every two neighbouring points are connected by a colored segment;
  3. The numbers of points from the beginning of the tail to the end should strictly increase.

Masha defines the length of the tail as the number of points in it. Also, she wants to paint some spines. To do so, Masha will paint all the segments, such that one of their ends is the endpoint of the tail. Masha defines the beauty of a hedgehog as the length of the tail multiplied by the number of spines. Masha wants to color the most beautiful hedgehog. Help her calculate what result she may hope to get.

Note that according to Masha's definition of a hedgehog, one segment may simultaneously serve as a spine and a part of the tail (she is a little girl after all). Take a look at the picture for further clarifications.

Input

First line of the input contains two integers n and m(2 ≤ n ≤ 100 0001 ≤ m ≤ 200 000) — the number of points and the number segments on the picture respectively.

Then follow m lines, each containing two integers ui and vi (1 ≤ ui, vi ≤ nui ≠ vi) — the numbers of points connected by corresponding segment. It's guaranteed that no two segments connect the same pair of points.

Output

Print the maximum possible value of the hedgehog's beauty.

Sample Input

Input
8 64 53 52 51 22 86 7
Output
9
Input
4 61 21 31 42 32 43 4
Output
12

Hint

The picture below corresponds to the first sample. Segments that form the hedgehog are painted red. The tail consists of a sequence of points with numbers 12 and 5. The following segments are spines: (25), (35) and (45). Therefore, the beauty of the hedgehog is equal to 3·3 = 9.



0 0
原创粉丝点击